package ec.simple;
import ec.Initializer;
import ec.EvolutionState;
import ec.util.Parameter;
import ec.Population;

/* 
 * SimpleInitializer.java
 * 
 * Created: Tue Aug 10 21:07:42 1999
 * By: Sean Luke
 */

/**
 * SimpleInitializer is a default Initializer which initializes a Population
 * by calling the Population's populate(...) method.  For most applications,
 * this should suffice.
 *
 * @author Sean Luke
 * @version 1.0 
 */

public class SimpleInitializer extends Initializer
    {
    public void setup(final EvolutionState state, final Parameter base)
	{ 
	}

    /** Creates, populates, and returns a new population by making a new
	population, calling setup(...) on it, and calling populate(...)
	on it.  Obviously, this is an expensive method.  It should only
	be called once typically in a run. */

    public Population initialPopulation(EvolutionState state)
	{
	Parameter base = new Parameter(P_POP);
	Population p = (Population) state.parameters.getInstanceForParameterEq(base,null,Population.class);  // Population.class is fine
	p.setup(state,base);
	p.populate(state);
	return p;
	}
    }
